import { csv, select,legendColor } from 'd3';
import { scatterPlot } from './scatterPlot';

// Impoart the data form github
const csvUrl = [
  'https://gist.githubusercontent.com/Sheshidharreddy/ef507a6ea2aba4e67876aaa27ae40041/raw/a819d4910aee49466d907d4950c1b4dc8a7f3ac9/irish.csv', 
].join('');
// This is the function which store data in each variable
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};
// Here we assign the window width and height
const width = window.innerWidth;
const height = window.innerHeight;
//For SVG graphs
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);


const xValue = (d) => d.petal_length;// for x value in graph 
const yValue = (d) => d.petal_width;// for y value in graph 
const rxValue = (d) => d.sepal_length;
const ryValue = (d) => d.sepal_width;
const speciesValue = (d) => d.species;
const colorValue = d => d.species;
const colorLabel = 'Species'; // it dispaly value in the window 

// This is for the dots representaion in grahp 
const main = async () => {
  const data = await csv(csvUrl, parseRow);
  const x = xValue((d) => d.petal_width);
  const y = yValue((d) => d.sepal_length);
  const marker = (d) => {
        	switch(d){ // all colours in  graph 
            case 'setosa':
              return 'red';
            case 'versicolor':
              return 'green';
            default:
              return 'blue';
          }
        }
// Allot value of X and Y in graph 
  const marks = data.map((d) => ({
          x: xValue((d) => d.petal_width),
          y: yValue((d) => d.sepal_length),
          species: speciesValue(d),
          color: marker(speciesValue(d)),
        	rx: rxValue(d),
          ry: ryValue(d),
                      
        }));
  
  
//This show that  scatterplot height and width 
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.petal_width)
    .yValue((d) => d.sepal_length)
    .margin({
      top:80,
      right: 20,
      bottom: 100,
      left: 75,

    })
    .radius(5);
  
   


 svg.selectAll('circle')// for the dots in the graph
      .data(marks)
      .join('circle')
      .attr('cx', (d) => d.x)
      .attr('cy', (d) => d.y)
      .attr('fill', (d) => d.color)
      .attr('rx', (d) => (d.rx))
      .attr('ry', (d) => (d.ry));
  
  //Here the allignment for the Title 
  svg.append("text")
    .attr("x", 450)
    .attr("y", 20)
  	.attr("font-weight","bold")
    .text("Iris Scatterplot")
    .style("font-size", "45px")
    .attr("alignment-baseline","middle")

		

    
       //for adding the Y lable 
    svg.append("text")
        .attr("x",-400)
        .attr("y",20)
  			.attr("font-weight","bold")
  			.attr("font-style","italic")
        .attr("font-size","14px")
        .attr("transform","rotate(-90)")
        .text("Sepal Length")
  
        // for adding the X lable
    svg.append("text")
        .attr("x",250)
        .attr("y",480)
  			.attr("font-weight","bold")
  			.attr("font-style","italic")
        .attr("font-size","14px")
        .text("Petal Length")

  
  const columns = [// for printing the X and Y values
    'petal_width',
    'sepal_width',
    'petal_length',
    'sepal_length',
  ];
  
  let i = 0;// the x and y values
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 5000);  // it changes screen for every 1 second 
};
main();
